package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.animation.ObjectAnimator

import android.widget.ImageView
import android.widget.TextView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.ModalDetallesCompra
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.Objeto
import com.example.ellegadodepintia.soundManager.SoundManager


class EfectoDetallesCompra(private val objeto: Objeto) : Efecto(100) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        val mensaje = "Has investigado el objeto que te estan ofreciendo"
        val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)

        imagenProtagonista?.let {
            val salto = ObjectAnimator.ofFloat(it, "translationY", 0f, -40f, 0f)
            salto.duration = 300
            salto.start()
        }
        val modalDetallesFragment = ModalDetallesCompra().apply {
            this.objeto = this@EfectoDetallesCompra.objeto
            this.onDismissListener = { accionRealizada ->
                if (accionRealizada) {
                    ejecutarCompra()
                }
            }
        }
        modalDetallesFragment.show(GameState.fragmentManager, "modalDetalles")

        return mensaje
    }

    private fun ejecutarCompra() {
        soundManager = SoundManager(context!!)
        val imagenProtagonista = context!!.findViewById<ImageView>(R.id.imagenProtagonista)

        imagenProtagonista?.let {
            val salto = ObjectAnimator.ofFloat(it, "translationY", 0f, -40f, 0f)
            salto.duration = 300
            salto.start()
        }

        if (GameState.jugador.monedas < objeto.coste){
            "¡No tienes suficientes monedas para comprar el objeto!".also { context!!.findViewById<TextView>(R.id.textoResultado).text = it }
        }else{
            soundManager.playSound(R.raw.sound_dineros,100)
            GameState.jugador.actualizarMonedas(GameState.jugador.monedas - objeto.coste)
            GameState.jugador.conseguirObjeto(objeto)
            GameState.eventoActual.actualizarFinalizado(true)
            "¡El objeto ha sido agregado a tu inventario!".also { context!!.findViewById<TextView>(R.id.textoResultado).text = it }
        }
    }
}
